<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>m17n ライブラリ: 文字テーブル</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- 作成： Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'検索');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>メインページ</span></a></li>
      <li><a href="pages.html"><span>関連ページ</span></a></li>
      <li><a href="modules.html"><span>モジュール</span></a></li>
      <li><a href="annotated.html"><span>データ構造</span></a></li>
      <li><a href="files.html"><span>ファイル</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="検索" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>文字テーブル<br/>
<small>
[<a class="el" href="group__m17nCore.html">コア API</a>]</small>
</h1>
<p>文字テーブルとそれに関する API.  
<a href="#_details">[詳細]</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>型定義</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef struct <a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">文字テーブルの型宣言.  <a href="#ga241f7150476db7182aecb944b711c546"></a><br/></td></tr>
<tr><td colspan="2"><h2>関数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#gad75c06739d6144b32fee4a85f530e339">mchartable</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *default_value)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">新しい文字テーブルを作る.  <a href="#gad75c06739d6144b32fee4a85f530e339"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#gabafef4ff85d483449fd8d3d2d4121f0b">mchartable_min_char</a> (<a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *table)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#ga8a6c1856bff9f9d60f4ba419ab7ad741">mchartable_max_char</a> (<a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *table)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#ga9f80ddddf110d65848c0156092da3a38">mchartable_lookup</a> (<a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *table, int c)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">文字テーブル中で文字に割り当てられた値を返す.  <a href="#ga9f80ddddf110d65848c0156092da3a38"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#ga398b6ad047423d8846c765d4fe94acd0">mchartable_set</a> (<a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *table, int c, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">文字テーブル中での文字の値を設定する.  <a href="#ga398b6ad047423d8846c765d4fe94acd0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#ga336b039ca5e3a08513edfcfd7dca8197">mchartable_set_range</a> (<a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *table, int from, int to, void *val)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">指定範囲の文字に値を設定する.  <a href="#ga336b039ca5e3a08513edfcfd7dca8197"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#ga4cadbd2cae1d2888caf587242b3d0cb3">mchartable_range</a> (<a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *table, int *from, int *to)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">値がデフォルトと異なる文字を探す.  <a href="#ga4cadbd2cae1d2888caf587242b3d0cb3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#ga802f22afa9b94c76821288bd50b2bb42">mchartable_map</a> (<a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *table, void *ignore, void(*func)(int, int, void *, void *), void *func_arg)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">文字テーブル中の文字に対して指定の関数を呼ぶ.  <a href="#ga802f22afa9b94c76821288bd50b2bb42"></a><br/></td></tr>
<tr><td colspan="2"><h2>変数</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nChartable.html#ga91e88555aace667aa53a16e5fbb4226c">Mchar_table</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">"char-table" という名前を持つシンボル.  <a href="#ga91e88555aace667aa53a16e5fbb4226c"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>説明</h2>
<p>文字テーブルとそれに関する API. </p>
<p>m17n ライブラリが扱う文字の空間は広大であるため、文字毎の情報を単純な配列に格納しようとすると、その配列は巨大になりすぎ、非実用的である。 しかし通常必要となる文字についての情報は、ある特定の範囲の文字にのみ付いていることが多い。 全文字に関して情報がある場合にも、連続した文字コードを持つ文字は同じ情報を持つことが多い。</p>
<p>このような傾向を利用して文字とその付加情報を効率的に格納するために、 m17n ライブラリは <em>文字テーブル</em> (chartable) と呼ぶオブジェクトを用いる。 文字テーブルは配列ではないが、アプリケーションプログラムは文字テーブルを配列の一種として扱うことができる。 ある文字についての特定の情報は、その情報を持つ文字テーブルをその文字のコードで引くこと で得られる。</p>
<p>文字テーブルは管理下オブジェクトである。 </p>
<hr/><h2>型定義</h2>
<a class="anchor" id="ga241f7150476db7182aecb944b711c546"></a><!-- doxytag: member="m17n&#45;core.h::MCharTable" ref="ga241f7150476db7182aecb944b711c546" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef struct <a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> <a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>文字テーブルの型宣言. </p>
<p><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546" title="文字テーブルの型宣言.">MCharTable</a> は <em>文字テーブル</em> (chartable) オブジェクトの型である。 内部構造はアプリケーションプログラムからは見えない。 </p>

</div>
</div>
<hr/><h2>関数</h2>
<a class="anchor" id="gad75c06739d6144b32fee4a85f530e339"></a><!-- doxytag: member="chartab.c::mchartable" ref="gad75c06739d6144b32fee4a85f530e339" args="(MSymbol key, void *default_value)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a>* mchartable </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>key</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>default_value</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>新しい文字テーブルを作る. </p>
<p>関数 <a class="el" href="group__m17nChartable.html#gad75c06739d6144b32fee4a85f530e339" title="新しい文字テーブルを作る.">mchartable()</a> はキーが <b>key</b> で要素のデフォルト値が <b>default_value</b> である新しい文字テーブルを作る。もし <b>key</b> が管理キーであれば、このテーブルの要素は（デフォルト値を含めて）管理下オブジェクトか NULL のいずれかである。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>処理が成功すれば <a class="el" href="group__m17nChartable.html#gad75c06739d6144b32fee4a85f530e339" title="新しい文字テーブルを作る.">mchartable()</a> は作成された文字テーブルへのポインタを返す。 失敗した場合は <code>NULL</code> を返し、外部変数 <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="m17n ライブラリのエラーコードを保持する外部変数.">merror_code</a> にエラーコードを設定する。 </dd></dl>

</div>
</div>
<a class="anchor" id="gabafef4ff85d483449fd8d3d2d4121f0b"></a><!-- doxytag: member="chartab.c::mchartable_min_char" ref="gabafef4ff85d483449fd8d3d2d4121f0b" args="(MCharTable *table)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mchartable_min_char </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td>
          <td class="paramname"> <em>table</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga8a6c1856bff9f9d60f4ba419ab7ad741"></a><!-- doxytag: member="chartab.c::mchartable_max_char" ref="ga8a6c1856bff9f9d60f4ba419ab7ad741" args="(MCharTable *table)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mchartable_max_char </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td>
          <td class="paramname"> <em>table</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga9f80ddddf110d65848c0156092da3a38"></a><!-- doxytag: member="chartab.c::mchartable_lookup" ref="ga9f80ddddf110d65848c0156092da3a38" args="(MCharTable *table, int c)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* mchartable_lookup </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td>
          <td class="paramname"> <em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>c</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>文字テーブル中で文字に割り当てられた値を返す. </p>
<p>関数 <a class="el" href="group__m17nChartable.html#ga9f80ddddf110d65848c0156092da3a38" title="文字テーブル中で文字に割り当てられた値を返す.">mchartable_lookup()</a> は文字テーブル <b>table</b> 中で文字 <b>c</b> に割り当てられた値を返す。<b>c</b> に対する明示的な値がなければ、<b>table</b> のデフォルト値を返す。<b>c</b> が妥当な文字でなければ、mchartable_lookup() は <code>NULL</code> を返し、外部変数 <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="m17n ライブラリのエラーコードを保持する外部変数.">merror_code</a> にエラーコードを設定する。</p>
<dl class="user"><dt><b>エラー:</b></dt><dd><code>MERROR_CHAR</code> </dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nChartable.html#ga398b6ad047423d8846c765d4fe94acd0" title="文字テーブル中での文字の値を設定する.">mchartable_set()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga398b6ad047423d8846c765d4fe94acd0"></a><!-- doxytag: member="chartab.c::mchartable_set" ref="ga398b6ad047423d8846c765d4fe94acd0" args="(MCharTable *table, int c, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mchartable_set </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td>
          <td class="paramname"> <em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>c</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>文字テーブル中での文字の値を設定する. </p>
<p>関数 <a class="el" href="group__m17nChartable.html#ga398b6ad047423d8846c765d4fe94acd0" title="文字テーブル中での文字の値を設定する.">mchartable_set()</a> は、文字テーブル <b>table</b> 中の文字 <b>c</b> に値 <b>val</b> を割り当てる。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>処理が成功すれば、mchartable_set() は 0 を返す。そうでなければ -1 を返し、外部変数 <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="m17n ライブラリのエラーコードを保持する外部変数.">merror_code</a> にエラーコードを設定する。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd><code>MERROR_CHAR</code> </dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nChartable.html#ga9f80ddddf110d65848c0156092da3a38" title="文字テーブル中で文字に割り当てられた値を返す.">mchartable_lookup()</a>, <a class="el" href="group__m17nChartable.html#ga336b039ca5e3a08513edfcfd7dca8197" title="指定範囲の文字に値を設定する.">mchartable_set_range()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga336b039ca5e3a08513edfcfd7dca8197"></a><!-- doxytag: member="chartab.c::mchartable_set_range" ref="ga336b039ca5e3a08513edfcfd7dca8197" args="(MCharTable *table, int from, int to, void *val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mchartable_set_range </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td>
          <td class="paramname"> <em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>to</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>val</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>指定範囲の文字に値を設定する. </p>
<p>関数 <a class="el" href="group__m17nChartable.html#ga336b039ca5e3a08513edfcfd7dca8197" title="指定範囲の文字に値を設定する.">mchartable_set_range()</a> は、文字テーブル <b>table</b> 中の <b>from</b> から <b>to</b> まで（両端を含む）の文字に、値として <b>val</b> を設定する。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>処理が成功すれば <a class="el" href="group__m17nChartable.html#ga336b039ca5e3a08513edfcfd7dca8197" title="指定範囲の文字に値を設定する.">mchartable_set_range()</a> は 0 を返す。そうでなければ -1 を返し、外部変数 <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="m17n ライブラリのエラーコードを保持する外部変数.">merror_code</a> にエラーコードを設定する。<b>from</b> が <b>to</b> より大きいときには、 <a class="el" href="group__m17nChartable.html#ga336b039ca5e3a08513edfcfd7dca8197" title="指定範囲の文字に値を設定する.">mchartable_set_range()</a> は何もせず、エラーも起こさない。</dd></dl>
<dl class="user"><dt><b>エラー:</b></dt><dd><code>MERROR_CHAR</code> </dd></dl>
<dl class="user"><dt><b>参照:</b></dt><dd><a class="el" href="group__m17nChartable.html#ga398b6ad047423d8846c765d4fe94acd0" title="文字テーブル中での文字の値を設定する.">mchartable_set()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="ga4cadbd2cae1d2888caf587242b3d0cb3"></a><!-- doxytag: member="chartab.c::mchartable_range" ref="ga4cadbd2cae1d2888caf587242b3d0cb3" args="(MCharTable *table, int *from, int *to)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mchartable_range </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td>
          <td class="paramname"> <em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&nbsp;</td>
          <td class="paramname"> <em>from</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int *&nbsp;</td>
          <td class="paramname"> <em>to</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>値がデフォルトと異なる文字を探す. </p>
<p>関数 <a class="el" href="group__m17nChartable.html#ga4cadbd2cae1d2888caf587242b3d0cb3" title="値がデフォルトと異なる文字を探す.">mchartable_range()</a> は文字テーブル <b>table</b> 中で、<b>table</b> のデフォルト値以外の値を持つ最初と最後の文字を探し、それぞれを <b>from</b> と <b>to</b> に設定する。すべての文字が値としてデフォルト値をとっている場合には <b>from</b> と <b>to</b> を -1に設定する。 </p>

</div>
</div>
<a class="anchor" id="ga802f22afa9b94c76821288bd50b2bb42"></a><!-- doxytag: member="chartab.c::mchartable_map" ref="ga802f22afa9b94c76821288bd50b2bb42" args="(MCharTable *table, void *ignore, void(*func)(int, int, void *, void *), void *func_arg)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mchartable_map </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nChartable.html#ga241f7150476db7182aecb944b711c546">MCharTable</a> *&nbsp;</td>
          <td class="paramname"> <em>table</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>ignore</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(int, int, void *, void *)&nbsp;</td>
          <td class="paramname"> <em>func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>func_arg</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>文字テーブル中の文字に対して指定の関数を呼ぶ. </p>
<p>関数 <a class="el" href="group__m17nChartable.html#ga802f22afa9b94c76821288bd50b2bb42" title="文字テーブル中の文字に対して指定の関数を呼ぶ.">mchartable_map()</a> は、文字テーブル <b>table</b> 中の文字に対して関数 <b>func</b> を呼ぶ。ただし<b>table</b> 中でも値が <b>ignore</b> である文字については関数呼び出しを行なわない。<b>ignore</b> と文字の値の比較は <code>==</code> で行なうので、文字列リテラルやポインタを使う際には注意を要する。</p>
<p><a class="el" href="group__m17nChartable.html#ga802f22afa9b94c76821288bd50b2bb42" title="文字テーブル中の文字に対して指定の関数を呼ぶ.">mchartable_map()</a> は、一文字ごとに <b>func</b> を呼ぶのではなく、関数呼び出しの回数を最適化しようとする。 すなわち、連続した文字が同じ値を持っていた場合には、その文字のまとまり全体について一度の関数呼び出 ししか行なわない。</p>
<p>文字のまとまりの大きさにかかわらず、<b>func</b> は <b>from</b>, <b>to</b>, <b>val</b>, <b>arg</b> の４引数で呼ばれる。<b>from</b> と <b>to</b> （両端を含む）は <b>val</b> を値として持つ文字の範囲を示し、<b>arg</b> は <b>func_arg</b> そのものである。</p>
<dl class="user"><dt><b>戻り値:</b></dt><dd>この関数は常に0を返す。 </dd></dl>

</div>
</div>
<hr/><h2>変数</h2>
<a class="anchor" id="ga91e88555aace667aa53a16e5fbb4226c"></a><!-- doxytag: member="chartab.c::Mchar_table" ref="ga91e88555aace667aa53a16e5fbb4226c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nChartable.html#ga91e88555aace667aa53a16e5fbb4226c">Mchar_table</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>"char-table" という名前を持つシンボル. </p>
<p>シンボル <code>Mchar_table</code> は名前 <code>"char-table"</code> を持つ。 </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>全て</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>データ構造</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>ファイル</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>関数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>変数</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>型定義</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>列挙型</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>列挙型の値</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>マクロ定義</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<!-- -*- coding: utf-8; -*- -->
<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-ja/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
